(function ($) {

  let allToggleOffCanvasClass = []
  const closingDelay = 0.2; //Overlay animation: delay between content and background

  SrOffCanvasContent = function ($scope) {
    this.node = $scope;
    if ($scope.find(".sr-offcanvas-toggle").length < 1) return;

    this.wrap = $scope.find(".sr-offcanvas-content-wrap");
    this.content = $scope.find(".sr-offcanvas-content");
    this.button = $scope.find(".sr-offcanvas-toggle");
    this.settings = this.wrap.data("settings");
    this.id = this.settings.content_id;
    this.transition = this.settings.transition;
    this.time_transition = this.settings.time_transition;
    this.esc_close = this.settings.esc_close;
    this.body_click_close = this.settings.body_click_close;
    this.open_offcanvas = this.settings.open_offcanvas;
    this.direction = this.settings.direction;
    this.duration = 500;
    this.toggleOffCanvasClass = (this.settings.class_toggle_offCanvas.length)?'.' + this.settings.class_toggle_offCanvas: false;

    this.init();
  };

  SrOffCanvasContent.prototype = {
    id: "",
    node: "",
    wrap: "",
    content: "",
    button: "",
    settings: {},
    transition: "",
    duration: 400,
    initialized: false,
    animations: ["3dyatch", "slide", "reveal", "push", "overlay"],
    bodyScroll: 0,
    toggleOffCanvasClass: '',


    init: function () {
      if(this.toggleOffCanvasClass){
        allToggleOffCanvasClass.push(this.toggleOffCanvasClass);
      }

      $(this.toggleOffCanvasClass).css('cursor','pointer');
      
      $(".sr_sticky_wrap").prepend('<div class="sr_toggleSticky"></div>');
      if (!this.wrap.length) {
        return;
      }

      if ($(".sr-offcanvas-container").length === 0) {
        $("body").wrapInner(
          '<div class="sr-offcanvas-container" />'
        );
        this.content.insertBefore(".sr-offcanvas-container");
      }

      if (this.wrap.find(".sr-offcanvas-content").length > 0) {
        if (
          $(".sr-offcanvas-container > .sr-offcanvas-content-" + this.id)
            .length > 0
        ) {
          $(
            ".sr-offcanvas-container > .sr-offcanvas-content-" + this.id
          ).remove();
        }
        if ($("body > .sr-offcanvas-content-" + this.id).length > 0) {
          $("body > .sr-offcanvas-content-" + this.id).remove();
        }
        $("body").prepend(this.wrap.find(".sr-offcanvas-content"));

        //this.hideElementWithAnims();
      }

      this.bindEvents();
    },

    destroy: function () {
      this.close();

      this.animations.forEach(function (animation) {
        if ($("body").hasClass("sr-offcanvas-content-" + animation)) {
          $("body").removeClass("sr-offcanvas-content-" + animation);
        }
      });
    },

    bindEvents: function () {
      if (this.open_offcanvas === "yes") {
        this.show();
      }

      var self = this;
      this.button.on("click", function (e) {
        self.show();
      });
      if(this.toggleOffCanvasClass){
        $(this.toggleOffCanvasClass).on("click", function () {
          self.show();
        });
      }

      $("body").delegate(
        ".sr-offcanvas-content .sr-offcanvas-close",
        "click",
        $.proxy(this.close, this)
      );

      if (this.esc_close === "yes") {
        this.closeESC();
      }
      if (this.body_click_close === "yes") {
        this.closeClick();
      }
    },

    toggleContent: function () {
      if (!$("body").hasClass("sr-offcanvas-content-open")) {
        this.show();
      } else {
        this.close();
      }
    },
    restartCanvaAnim: function () {
      var $is_edit_mode = elementorFrontend.isEditMode();

      if ($is_edit_mode && typeof $invisibleRemoved === "undefined") {
        var animatedRows = this.content.find(".elementor-invisible"); // in editor, elementor put elementor-invisible class on the animated rows so we need to hack this.
      } else {
        var animatedRows = this.content.find(".animated");
      }

      animatedRows.each(function () {
        var $element = $(this);
        var timeout;
        var $animType = $element.data("settings")["_animation"];
        var $animDelay = $element.data("settings")["_animation_delay"] || 0;
        clearTimeout(timeout);
        $element.css("opacity", 0);
        $element.removeClass($animType);
        timeout = setTimeout(function () {
          if ($is_edit_mode) {
            $element.removeClass("elementor-invisible");
            $invisibleRemoved = true;
            $element.addClass("animated");
          }
          $element.addClass($animType);
          $element.css("opacity", 1);
        }, $animDelay);
      });
    },

    show: function () {
      if( $('.sr-offcanvas-content-' + this.id).hasClass('sr-closing') )
        return
  
      if (document.querySelector("#overlay") != null) {
        // #overlay doesnt exist when we edit an "header" post with the elementor editor
        var scrollbarWidth =
          document.querySelector("#overlay").offsetWidth -
          document.querySelector("body").offsetWidth;
      } else {
        var scrollbarWidth = 0;
      }
      var bodyScroll = $(document).scrollTop();

      $(
        ".sr-offcanvas-content-" + this.id + ", .sr-offcanvas-container"
      ).addClass("sr-offcanvas-content-visible");
      $(".sr-offcanvas-content-" + this.id).addClass("sr-offcanvas-opened");
      $("body").addClass("sr-offcanvas-content-" + this.direction);
      $("body").addClass("sr-offcanvas-content-open");
      $("body").addClass("sr-offcanvas-content-" + this.id + "-open");
      $("body").addClass("sr-offcanvas-content-reset");
      $("body").attr("sr-oc-transition", this.transition);
      if(this.transition == 'overlay'){
        $("body").attr("sr-oc-time-transition", this.time_transition);//Set in the Elementor Editor
      }else{
        $("body").attr("sr-oc-time-transition", this.duration);
      }
      $("body").attr("sr-oc-direction", this.direction);
      $("body").attr("sr-oc-id", this.id);
      this.restartCanvaAnim();

      $('.sr-offcanvas-content-' + this.id + '.sr-offcanvas-overlay .sr-offcanvas-body').css('transition-delay', this.time_transition * ( closingDelay + 0.2 ) + 'ms');

      if (this.transition == "3dyatch") {
        if ($("html").hasClass("wp-admin-bar")) {
          $("#wrapper").css("padding-top", "32px");
          if (bodyScroll > 32) {
            $("#pusher").scrollTop(bodyScroll);
          } else {
            $("#pusher").scrollTop(bodyScroll + 32);
          }
          $("header.sr-header").css("top", bodyScroll + 32);
        } else {
          $("#pusher").scrollTop(bodyScroll);

          $("header.sr-header").css("top", bodyScroll);
          if (scrollbarWidth) {
            $("#pusher").css("width", "calc(100% - " + scrollbarWidth + "px)");
          }
        }
        $("header.sr-header").prependTo("#pusher");

        if (scrollbarWidth) {
          $("#pusher").css("width", "calc(100% - " + scrollbarWidth + "px)");
        }
      }

      let canvasTimeTransition = Number(this.time_transition);
      let canvasID = this.id;
      $('.sr-offcanvas-content-' + canvasID).addClass('sr-opening');
      setTimeout(function () {
        $('.sr-offcanvas-content-' + canvasID).removeClass('sr-opening');
      }, canvasTimeTransition + (canvasTimeTransition * closingDelay) );
    },

    close: function () {
      if( $('.sr-offcanvas-content-' + this.id).hasClass('sr-opening') )
        return

      if (!$("body").find(".sr-offcanvas-opened").length) return;
      let canvasID = $("body").attr('sr-oc-id');
      let canvasDirection = $("body").attr('sr-oc-direction');
      let canvasTransition = $("body").attr('sr-oc-transition');
      let canvasTimeTransition = Number($("body").attr('sr-oc-time-transition'));
      let pusherScroll = $("#pusher").scrollTop();
      if (pusherScroll <= 32) {
        pusherScroll = 0;
      }
      
      $('body').removeAttr('sr-oc-direction');
      $('body').removeAttr('sr-oc-time-transition');
      $("body").removeClass("sr-offcanvas-content-open");
      $("body").removeClass("sr-offcanvas-content-" + canvasID + "-open");
      $(".sr-offcanvas-opened").removeClass("sr-offcanvas-opened");
      $('.sr-offcanvas-content-' + canvasID).addClass('sr-closing');

      $('.sr-offcanvas-content-' + this.id + '.sr-offcanvas-overlay').css('transition-delay', this.time_transition * closingDelay + 'ms');

      setTimeout(function () {
        $("body").removeClass("sr-offcanvas-content-reset");
        $("body").removeClass("sr-offcanvas-content-" + canvasDirection);
        $('body').removeAttr('sr-oc-transition');
        $(
          ".sr-offcanvas-content-" +
            canvasID +
            ", .sr-offcanvas-container"
        ).removeClass("sr-offcanvas-content-visible");
        $('body').removeAttr('sr-oc-id');
        $('.sr-offcanvas-content-' + canvasID).removeClass('sr-closing');
        if (canvasTransition == "3dyatch") {
          $("header.sr-header").insertAfter("#overlay");
          $("header.sr-header").css("top", "unset");
          $("#pusher").css("width", "100%");
          $("#wrapper").css("padding-top", "0px");
          $(document).scrollTop(pusherScroll);
        }
      }, canvasTimeTransition + (canvasTimeTransition * closingDelay) );
    },

    closeESC: function () {
      var self = this;

      if ("" === self.settings.esc_close) {
        return;
      }

      // menu close on ESC key
      $(document).on("keydown", function (e) {
        if (e.keyCode === 27) {
          // ESC
          self.close();
        }
      });
    },

    closeClick: function () {
      var self = this;
      $(window).on("click", function (e) {
        let sr_close = true;
        if (
          // DONT CLICK ON THE ITEMS BELOW
          $(e.target).is(".sr-offcanvas-content") ||
          $(e.target).parents(".sr-offcanvas-content").length > 0 ||
          $(e.target).is(".sr-offcanvas-toggle") ||
          $(e.target).parents(".sr-offcanvas-toggle").length > 0 
        ) {
          sr_close = false;
        } 
        $(allToggleOffCanvasClass).each(function () {
          if($(e.target).parents(String(this)).length > 0){
            sr_close = false;
          } 
        });
        if(sr_close){
          self.close();
        }
      });
    },
  };
})(jQuery);

$ = jQuery;

var globalExtraGap = 250;
var sr_scrollDirection = null;
var sr_lastScrollTop = 0;
$(window).scroll(function () {
  let st = $(this).scrollTop();
  if (st > sr_lastScrollTop) {
    sr_scrollDirection = 'down';
  } else {
    sr_scrollDirection = 'up';
  }
  sr_lastScrollTop = st;
});

function _classCallCheck(instance, Constructor) {
  if (!(instance instanceof Constructor)) {
    throw new TypeError("Cannot call a class as a function");
  }
}

function _defineProperties(target, props) {
  for (var i = 0; i < props.length; i++) {
    var descriptor = props[i];
    descriptor.enumerable = descriptor.enumerable || false;
    descriptor.configurable = true;
    if ("value" in descriptor) descriptor.writable = true;
    Object.defineProperty(target, descriptor.key, descriptor);
  }
}

function _createClass(Constructor, protoProps, staticProps) {
  if (protoProps) _defineProperties(Constructor.prototype, protoProps);
  if (staticProps) _defineProperties(Constructor, staticProps);
  return Constructor;
}

/**
 * Sticky.js
 * Library for sticky elements written in vanilla javascript. With this library you can easily set sticky elements on your website. It's also responsive.
 *
 * @version 1.3.0
 * @author Rafal Galus <biuro@rafalgalus.pl>
 * @website https://rgalus.github.io/sticky-js/
 * @repo https://github.com/rgalus/sticky-js
 * @license https://github.com/rgalus/sticky-js/blob/master/LICENSE
 */
var SRSticky = /*#__PURE__*/ (function () {
  /**
   * Sticky instance constructor
   * @constructor
   * @param {string} selector - Selector which we can find elements
   * @param {string} options - Global options for sticky elements (could be overwritten by data-{option}="" attributes)
   */
  function SRSticky() {
    var selector =
      arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : "";
    var options =
      arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};

    _classCallCheck(this, SRSticky);

    this.selector = selector;
    this.elements = [];
    this.version = "1.3.0";
    this.vp = this.getViewportSize();
    this.body = document.querySelector("body");
    this.options = {
      wrap: options.wrap || false,
      wrapWith: options.wrapWith || '<span class="sr_sticky_wrap"></span>',
      marginTop: options.marginTop || 0,
      marginBottom: options.marginBottom || 0,
      stickyFor: options.stickyFor || 0,
      stickyClass: options.stickyClass || null,
      stickyContainer: options.stickyContainer || "body",
    };
    this.updateScrollTopPosition = this.updateScrollTopPosition.bind(this);
    this.updateScrollTopPosition();
    window.addEventListener("load", this.updateScrollTopPosition);
    window.addEventListener("scroll", this.updateScrollTopPosition);
    this.run();
  }
  /**
   * Function that waits for page to be fully loaded and then renders & activates every sticky element found with specified selector
   * @function
   */

  _createClass(SRSticky, [
    {
      key: "run",
      value: function run() {
        var _this = this;

        // wait for page to be fully loaded
        var pageLoaded = setInterval(function () {
          if (document.readyState === "complete") {
            clearInterval(pageLoaded);
            var elements = document.querySelectorAll(_this.selector);

            _this.forEach(elements, function (element) {
              return _this.renderElement(element);
            });
          }
        }, 10);
      },
      /**
       * Function that assign needed variables for sticky element, that are used in future for calculations and other
       * @function
       * @param {node} element - Element to be rendered
       */
    },
    {
      key: "renderElement",
      value: function renderElement(element) {
        var _this2 = this;

        // create container for variables needed in future
        element.sticky = {}; // set default variables

        element.sticky.active = false;
        element.sticky.marginTop =
          parseInt(element.getAttribute("data-margin-top")) ||
          this.options.marginTop;
        element.sticky.marginBottom =
          parseInt(element.getAttribute("data-margin-bottom")) ||
          this.options.marginBottom;
        element.sticky.stickyFor =
          parseInt(element.getAttribute("data-sticky-for")) ||
          this.options.stickyFor;
        element.sticky.stickyClass =
          element.getAttribute("data-sticky-class") || this.options.stickyClass;
        element.sticky.wrap = element.hasAttribute("data-sticky-wrap")
          ? true
          : this.options.wrap; // @todo attribute for stickyContainer
        // element.sticky.stickyContainer = element.getAttribute('data-sticky-container') || this.options.stickyContainer;

        element.sticky.stickyContainer = this.options.stickyContainer;
        element.sticky.container = this.getStickyContainer(element);
        element.sticky.container.rect = this.getRectangle(
          element.sticky.container
        );
        element.sticky.rect = this.getRectangle(element); // fix when element is image that has not yet loaded and width, height = 0

        if (element.tagName.toLowerCase() === "img") {
          element.onload = function () {
            return (element.sticky.rect = _this2.getRectangle(element));
          };
        }

        if (element.sticky.wrap) {
          if (!$(element).parent().hasClass('sr_sticky_wrap')) {
            this.wrapElement(element);
          }
        } // activate rendered element

        this.activate(element);
      },
      /**
       * Wraps element into placeholder element
       * @function
       * @param {node} element - Element to be wrapped
       */
    },
    {
      key: "wrapElement",
      value: function wrapElement(element) {
        element.insertAdjacentHTML(
          "beforebegin",
          element.getAttribute("data-sticky-wrapWith") || this.options.wrapWith
        );
        element.previousSibling.appendChild(element);
      },
      /**
       * Function that activates element when specified conditions are met and then initalise events
       * @function
       * @param {node} element - Element to be activated
       */
    },
    {
      key: "activate",
      value: function activate(element) {
        if (
          element.sticky.rect.top + element.sticky.rect.height <
          element.sticky.container.rect.top +
          element.sticky.container.rect.height &&
          element.sticky.stickyFor < this.vp.width &&
          !element.sticky.active
        ) {
          element.sticky.active = true;
        }

        if (this.elements.indexOf(element) < 0) {
          this.elements.push(element);
        }

        if (!element.sticky.resizeEvent) {
          this.initResizeEvents(element);
          element.sticky.resizeEvent = true;
        }

        if (!element.sticky.scrollEvent) {
          this.initScrollEvents(element);
          element.sticky.scrollEvent = true;
        }

        this.setPosition(element);
      },
      /**
       * Function which is adding onResizeEvents to window listener and assigns function to element as resizeListener
       * @function
       * @param {node} element - Element for which resize events are initialised
       */
    },
    {
      key: "initResizeEvents",
      value: function initResizeEvents(element) {
        var _this3 = this;

        element.sticky.resizeListener = function () {
          return _this3.onResizeEvents(element);
        };

        window.addEventListener("resize", element.sticky.resizeListener);
      },
      /**
       * Removes element listener from resize event
       * @function
       * @param {node} element - Element from which listener is deleted
       */
    },
    {
      key: "destroyResizeEvents",
      value: function destroyResizeEvents(element) {
        window.removeEventListener("resize", element.sticky.resizeListener);
      },
      /**
       * Function which is fired when user resize window. It checks if element should be activated or deactivated and then run setPosition function
       * @function
       * @param {node} element - Element for which event function is fired
       */
    },
    {
      key: "onResizeEvents",
      value: function onResizeEvents(element) {
        this.vp = this.getViewportSize();
        element.sticky.rect = this.getRectangle(element);
        element.sticky.container.rect = this.getRectangle(
          element.sticky.container
        );

        if (
          element.sticky.rect.top + element.sticky.rect.height <
          element.sticky.container.rect.top +
          element.sticky.container.rect.height &&
          element.sticky.stickyFor < this.vp.width &&
          !element.sticky.active
        ) {
          element.sticky.active = true;
        } else if (
          element.sticky.rect.top + element.sticky.rect.height >=
          element.sticky.container.rect.top +
          element.sticky.container.rect.height ||
          (element.sticky.stickyFor >= this.vp.width && element.sticky.active)
        ) {
          element.sticky.active = false;
        }

        this.setPosition(element);
      },
      /**
       * Function which is adding onScrollEvents to window listener and assigns function to element as scrollListener
       * @function
       * @param {node} element - Element for which scroll events are initialised
       */
    },
    {
      key: "initScrollEvents",
      value: function initScrollEvents(element) {
        var _this4 = this;

        element.sticky.scrollListener = function () {
          return _this4.onScrollEvents(element);
        };

        window.addEventListener("scroll", element.sticky.scrollListener);
      },
      /**
       * Removes element listener from scroll event
       * @function
       * @param {node} element - Element from which listener is deleted
       */
    },
    {
      key: "destroyScrollEvents",
      value: function destroyScrollEvents(element) {
        window.removeEventListener("scroll", element.sticky.scrollListener);
      },
      /**
       * Function which is fired when user scroll window. If element is active, function is invoking setPosition function
       * @function
       * @param {node} element - Element for which event function is fired
       */
    },
    {
      key: "onScrollEvents",
      value: function onScrollEvents(element) {
        if (element.sticky && element.sticky.active) {
          this.setPosition(element);
        }
      },
      /**
       * Main function for the library. Here are some condition calculations and css appending for sticky element when user scroll window
       * @function
       * @param {node} element - Element that will be positioned if it's active
       */
    },
    {
      key: "setPosition",
      value: function setPosition(element) {
        if (typeof ($(element).data('settings')) != 'undefined' && $(element).data('settings').sr_sticky_hideonscroll == '1') {
          sr_hideonscroll = true;
        } else {
          sr_hideonscroll = false;
        }

        //When HideOnScroll is Enable, we need this function to get the element BOTTOM rather than TOP.
        function positionModification() {
          if (element.sticky.active && sr_hideonscroll) { //When the hideonscroll option is enable
            let modifValue = $(element).outerHeight() + element.sticky.marginTop;
            return modifValue;
          }
          return 0;
        }
        if (!sr_hideonscroll) {
          this.css(element, {
            position: "",
            width: "",
            top: "",
            left: "",
          });
        }

        if (
          this.vp.height < element.sticky.rect.height ||
          !element.sticky.active
        ) {
          return;
        }

        if (!element.sticky.rect.width) {
          element.sticky.rect = this.getRectangle(element);
        }

        if (element.sticky.wrap) {
          this.css(element.parentNode, {
            display: "block",
            height: element.sticky.rect.height + "px",
          });
        }

        /* WHEN HIDE ON SCROLL is Enable*/
        if (sr_hideonscroll) {
          //Before scrolling, When we are above the breakpoint
          if (
            ($('body').hasClass('admin-bar') && this.scrollTop <= element.sticky.rect.top - element.sticky.marginTop + 32 && sr_scrollDirection == null) ||
            (!$('body').hasClass('admin-bar') && this.scrollTop <= element.sticky.rect.top - element.sticky.marginTop && sr_scrollDirection == null)
          ) {
            $(element).addClass('sr_static');
          }
          //Scroll Down after the breakpoint (The breakpoint is the sicky element bottom)
          if (
            (this.scrollTop > element.sticky.rect.top + positionModification() - element.sticky.marginTop + globalExtraGap && sr_scrollDirection == 'down') //250 is the extraGap before make the element "fixed"
          ) {
            this.css(element, {
              position: 'fixed',
              top: element.sticky.marginTop + "px",
              left: element.sticky.rect.left + "px",
            });
            if ($(element).hasClass('sr_hidden')) {
              $(element).removeClass('sr_static');
            }
            $(element).addClass('sr_hidden');
          }

          //Scroll Up after the breakpoint (The breakpoint is the sicky element top)
          if (
            ($('body').hasClass('admin-bar') && this.scrollTop <= element.sticky.rect.top - element.sticky.marginTop + 32 && sr_scrollDirection == 'up') ||
            (!$('body').hasClass('admin-bar') && this.scrollTop <= element.sticky.rect.top - element.sticky.marginTop && sr_scrollDirection == 'up')
          ) {
            this.css(element, {
              position: '',
              top: '',
              left: '',
              width: ''
            });
            $(element).addClass('sr_static');
          }
        } else {
          /* When HIDE ON SCROLL is disable*/

          if (
            element.sticky.rect.top === 0 &&
            element.sticky.container === this.body
          ) {
            this.css(element, {
              position: "fixed",
              top: element.sticky.marginTop + "px", //fix par max. Original: element.sticky.rect.top + 'px',
              left: element.sticky.rect.left + "px",
            });

            if (element.sticky.stickyClass) {
              element.classList.add(element.sticky.stickyClass);
            }
          } else if (
            this.scrollTop >
            element.sticky.rect.top - element.sticky.marginTop
          ) {
            this.css(element, {
              position: "fixed",
              left: element.sticky.rect.left + "px",
            });

            if (
              this.scrollTop +
              element.sticky.rect.height +
              element.sticky.marginTop >
              element.sticky.container.rect.top +
              element.sticky.container.offsetHeight -
              element.sticky.marginBottom
            ) {
              if (element.sticky.stickyClass) {
                element.classList.remove(element.sticky.stickyClass);
              }

              this.css(element, {
                top:
                  element.sticky.container.rect.top +
                  element.sticky.container.offsetHeight -
                  (this.scrollTop +
                    element.sticky.rect.height +
                    element.sticky.marginBottom) +
                  "px",
              });
            } else {
              if (element.sticky.stickyClass) {
                element.classList.add(element.sticky.stickyClass);
              }

              this.css(element, {
                top: element.sticky.marginTop + "px",
              });
            }
          } else {
            if (element.sticky.stickyClass) {
              element.classList.remove(element.sticky.stickyClass);
            }

            this.css(element, {
              position: "",
              width: "",
              top: "",
              left: "",
            });

            if (element.sticky.wrap) {
              this.css(element.parentNode, {
                //display: "",
                width: "",
                height: "",
              });
            }
          }
        }

      },







      /**
       * Function that updates element sticky rectangle (with sticky container), then activate or deactivate element, then update position if it's active
       * @function
       */
    },
    {
      key: "update",
      value: function update() {
        var _this5 = this;

        this.forEach(this.elements, function (element) {
          element.sticky.rect = _this5.getRectangle(element);
          element.sticky.container.rect = _this5.getRectangle(
            element.sticky.container
          );

          _this5.activate(element);

          _this5.setPosition(element);
        });
      },
      /**
       * Destroys sticky element, remove listeners
       * @function
       */
    },
    {
      key: "destroy",
      value: function destroy() {
        var _this6 = this;

        window.removeEventListener("load", this.updateScrollTopPosition);
        window.removeEventListener("scroll", this.updateScrollTopPosition);
        this.forEach(this.elements, function (element) {
          _this6.destroyResizeEvents(element);

          _this6.destroyScrollEvents(element);

          delete element.sticky;
        });
      },
      /**
       * Function that returns container element in which sticky element is stuck (if is not specified, then it's stuck to body)
       * @function
       * @param {node} element - Element which sticky container are looked for
       * @return {node} element - Sticky container
       */
    },
    {
      key: "getStickyContainer",
      value: function getStickyContainer(element) {
        var container = element.parentNode;

        while (
          !container.hasAttribute("data-sticky-container") &&
          !container.parentNode.querySelector(element.sticky.stickyContainer) &&
          container !== this.body
        ) {
          container = container.parentNode;
        }

        return container;
      },
      /**
       * Function that returns element rectangle & position (width, height, top, left)
       * @function
       * @param {node} element - Element which position & rectangle are returned
       * @return {object}
       */
    },
    {
      key: "getRectangle",
      value: function getRectangle(element) {
        this.css(element, {
          position: "",
          width: "",
          top: "",
          left: "",
        });
        var width = Math.max(
          element.offsetWidth,
          element.clientWidth,
          element.scrollWidth
        );
        var height = Math.max(
          element.offsetHeight,
          element.clientHeight,
          //---Remove line below: We dont want to calculate opened sub-menu
          //element.scrollHeight 
        );
        height =
          width === 0
            ? (height = 0)
            : height +
            parseInt($(element).css("margin-top"), 10) +
            parseInt($(element).css("margin-bottom"), 10);
        // if width is 0 it means element is hidden so dont hide an height to the span

        var top = 0;
        var left = 0;

        do {
          top += element.offsetTop || 0;
          left += element.offsetLeft || 0;
          element = element.offsetParent;
        } while (element);

        return {
          top: top,
          left: left,
          width: width,
          height: height,
        };
      },
      /**
       * Function that returns viewport dimensions
       * @function
       * @return {object}
       */
    },
    {
      key: "getViewportSize",
      value: function getViewportSize() {
        return {
          width: Math.max(
            document.documentElement.clientWidth,
            window.innerWidth || 0
          ),
          height: Math.max(
            document.documentElement.clientHeight,
            window.innerHeight || 0
          ),
        };
      },
      /**
       * Function that updates window scroll position
       * @function
       * @return {number}
       */
    },
    {
      key: "updateScrollTopPosition",
      value: function updateScrollTopPosition() {
        this.scrollTop =
          (window.pageYOffset || document.scrollTop) -
          (document.clientTop || 0) || 0;
      },
      /**
       * Helper function for loops
       * @helper
       * @param {array}
       * @param {function} callback - Callback function (no need for explanation)
       */
    },
    {
      key: "forEach",
      value: function forEach(array, callback) {
        for (var i = 0, len = array.length; i < len; i++) {
          callback(array[i]);
        }
      },
      /**
       * Helper function to add/remove css properties for specified element.
       * @helper
       * @param {node} element - DOM element
       * @param {object} properties - CSS properties that will be added/removed from specified element
       */
    },
    {
      key: "css",
      value: function css(element, properties) {
        for (var property in properties) {
          if (properties.hasOwnProperty(property)) {
            element.style[property] = properties[property];
          }
        }
      },
    },
  ]);

  return SRSticky;
})();
/**
 * Export function that supports AMD, CommonJS and Plain Browser.
 */

(function (root, factory) {
  if (typeof exports !== "undefined") {
    module.exports = factory;
  } else if (typeof define === "function" && define.amd) {
    define([], function () {
      return factory;
    });
  } else {
    root.SRSticky = factory;
  }
})(this, SRSticky);

if (IRON === undefined) {
  var IRON = {};
}
if (IRON.state === undefined) {
  IRON.state = {};
  IRON.state.logo = {};
  IRON.state.logo.page_logo_select_elementor = null;
}
var sticky = [];

IRON.initEveryTime = function () {
  if (typeof sticky !== "undefined") {
    const SonaarResizeObserver = new ResizeObserver((entries) => {
      $(".sr-sticky").each(function () {
        var stickyID = $(this).attr("data-id");
        if ( typeof sticky[stickyID] != 'undefined' && sticky[stickyID].elements.length) {
          sticky[stickyID].onResizeEvents(sticky[stickyID].elements[0]);
        }
      });
    });
    // start observing a DOM node
    SonaarResizeObserver.observe(document.body);
  }
};
IRON.RemoveHrefFromMenu = function () {
  /* Remove link on ancestor item from responsive menu */
  if (
    (!iron_vars.menu.unveil_all_mobile_items &&
      ($(".responsive-header").length || $(".side-menu").length)) ||
    $(".sr-e-menu.sr-menu--vertical").length
  ) {
    if ($(".sr-e-menu.sr-menu--vertical").length) {
      $(".sr-e-menu.sr-menu--vertical .menu-item-has-children>a").attr(
        "href",
        "#"
      );
    } else {
      $(".menu-item-has-children>a").attr("href", "#");
    }
  }
};
IRON.setupElementorMenu = function () {
  //To apply the margin of the current sticky item.
  $(".sr-e-menu-toggle")
    .off()
    .on("click", function (e) {
      $(this).toggleClass("sr-toggle-active");
    });

  //Set Stretch Menu mobile
  $(".sr-e-menu--stretch .sr-e-mobile").each(function () {
    var sr_menuPosition = this.getBoundingClientRect();
    var currentLeft = parseInt($(this).css("left"), 10);
    if (isNaN(currentLeft)) {
      currentLeft = 0;
    }
    sr_menuPosition = -1 * sr_menuPosition.left + currentLeft + "px";
    $(this).css("left", sr_menuPosition);
    $(this).css("top", $(".sr-e-menu-toggle").outerHeight());
  });

  $(".sr-e-menu.sr-menu--vertical li a")
    .off()
    .on("click", function (e) {
      // toggle in all case active class
      var anchor = $(this);
      var anchorParents = anchor.parents("li");

      $(this)
        .parents(".sr-e-menu")
        .find("li")
        .each(function (el) {
          if (!_.contains(anchorParents, this)) {
            $(this).removeClass("active");
          }
        });

      $(this).closest("li").toggleClass("active");

      if (
        $(this).attr("href") === "#" ||
        $(this).closest("li").hasClass("menu-item-has-children")
      ) {
        //prevent
        e.preventDefault();
      } else {
        $(".sr-e-menu.sr-menu--vertical").removeClass("visible");
        $(".sr-e-menu.sr-menu--vertical").scrollTop(0);
      }
    });

  // Let close the offcanva when clicking on an item with a # href EXCEPT if ahref has children
  $('.sr-offcanvas-content a[href*="#"]').click(function () {
    if ($(this).parents(".menu-item-has-children").length) return;

    $(window).trigger("click");
  });

  // Let close the toggle menu when clicking on an item with a # href EXCEPT if ahref has children
  $('.sr-e-menu--toggle .sr-e-mobile a[href*="#"]').click(function () {
    if ($(this).parents(".menu-item-has-children").length) return;

    IRON.toggleElementorMenuClose();
  });
  // Collision: avoid submenu to be out of viewport.
  $(".sr-e-menu ul")
    .find(">li a")
    .on("mouseover", function (e) {
      // check if has submenu
      if ($(this).find(" + ul").length > 0) {
        var $_this = $(this).find(" + ul");
        if (
          $_this.outerWidth(true) + $_this.offset().left >
          $(window).width()
        ) {
          $(this).parent().addClass("collision");
        }
      }
    });
  // Close Submenu when we navigate
  $(".sr-header .sub-menu a").on("click", function () {
    $(".sr-header .menu-item").css("pointer-events", "none");
    setTimeout(function () {
      $(".sr-header .menu-item").css("pointer-events", "auto");
    }, 100);
  });

  //Elementor PRo editor "Edit Header" button hide and show
  $(
    ".elementor-html .sr-over-content #wrapper .elementor-section-wrap>section:first-of-type"
  ).on({
    mouseenter: function () {
      $(".sr-header>.elementor").addClass("sr-elementor-focus");
    },
    mouseleave: function () {
      $(".sr-header>.elementor").removeClass("sr-elementor-focus");
    },
  });

  //Elementor Editor - Header device label link
  $('html.elementor-html .single-block section, html.elementor-html header .elementor-section').each(function () {
    let sr_deviceButton = '<div class="sr-device-label"><span class="sr-device-link sr-mobile-link">Mobile</span><span class="sr-seperator-1"> + </span><span class="sr-tablet-link sr-device-link">Tablet</span><span class="sr-seperator-2"> + </span><span class="sr-desktop-link sr-device-link">Desktop</span><span> Version</span></div>';
    if (!$(this).find('.sr-device-label').length) {
      $(this).append(sr_deviceButton);
    }
  });

  $('.sr-mobile-link').on('click', function () {
    elementor.changeDeviceMode('mobile');
  })
  $('.sr-tablet-link').on('click', function () {
    elementor.changeDeviceMode('tablet');
  })
  $('.sr-desktop-link').on('click', function () {
    elementor.changeDeviceMode('desktop');
  })
};

IRON.toggleElementorMenuClose = function () {
  if (!$(".sr-toggle-active").length) return;

  $(".sr-e-menu-toggle").removeClass("sr-toggle-active");
};

IRON.elementorHeaderLogo = function () { //Sonaar Theme only
  if ($('.sr-header').find(".sr-logo-secondary").length < 1) {
    $('.sr-header').addClass("sr-logo-primary-reveal");
    return;
  }

  $('.sr-header').addClass("sr-logo-reveal");
  if (
    "secondary" === IRON.state.logo.page_logo_select_elementor &&
    $('.sr-header').find(".sr-logo-secondary").length > 0
  ) {
    $('.sr-header').addClass("sr-logo-secondary-selected");
  } else {
    $('.sr-header').removeClass("sr-logo-secondary-selected");
  }
};


(function ($) {
  "use strict";
  var sroffcanvas = [];
  var canvasID;
  var isEditMode = false;

  $(window).on("elementor/frontend/init", function () {
    jQuery(sticky).each(function () {
      if (typeof this !== "undefined") {
        this.destroy();
      }
    });
    sticky = [];

    IRON.setupElementorMenu();

    setTimeout(function () {
      window.dispatchEvent(new Event("resize"));
    }, 100);

    var SectionExtends = elementorModules.frontend.handlers.Base.extend({
      onInit: function onInit() {
        elementorModules.frontend.handlers.Base.prototype.onInit.apply(
          this,
          arguments
        );
        this.initSectionExtends();
      },
      isSrSticky: function () {
        return this.$element.hasClass("sr-sticky");
      },

      onElementChange: function (changedProp) {
        if (changedProp === "sr_sticky") {
          if ("" !== this.getElementSettings("sr_sticky")) {
            //this.$element.addClass( 'sr-sticky' );
          } else {
            this.$element.removeClass("sr-sticky");
            var stickyElement = sticky[this.$element.attr("data-id")];
            window.removeEventListener(
              "load",
              stickyElement.updateScrollTopPosition
            );
            window.removeEventListener(
              "scroll",
              stickyElement.updateScrollTopPosition
            );
          }
        }
      },
      initSectionExtends: function () {
        if (typeof this.getElementSettings("sr_sticky_on") !== "undefined") {
          var currentDeviceMode = elementorFrontend.getCurrentDeviceMode();
          var activeDevices = this.getElementSettings("sr_sticky_on");

          if (-1 !== activeDevices.indexOf(currentDeviceMode)) {
            this.$element.addClass("sr-sticky");

            var stickyOffset = this.getElementSettings("sr_sticky_offset");
            var hideAfter = this.getElementSettings("sr_hide_after");

            if (1 == this.getElementSettings("sr_sticky_hideonscroll")) {
              // HIDE THE STICKY AFTER SCROLL
              var hideonscroll = true;
            } else {
              // DONT HIDE THE STICKY AFTER SCROLL
              var hideonscroll = false;
            }

            this.$element.each(function () {
              var el = this;
              var lastScrollTop = 0;
              var extraGap = 0;
              if (hideonscroll) {
                var elementHeight = el.offsetHeight;//When the hideonscroll option is enable, the sticky element only stick on scrollup
                extraGap = globalExtraGap || 0;
                hideAfter = 0;
              } else {
                var elementHeight = 0;
              }
              var hideAt = $(el).offset().top + hideAfter - stickyOffset; // make sure hideAt is 0 if dont hide the sticky

              $(el).addClass("sr_hideOnScroll");
              $(document).on("scroll touchmove", function (e) {
                var offset = $(this).scrollTop();
                var st = $(this).scrollTop();
                if (offset > hideAt + elementHeight) {
                  if (offset > hideAt + elementHeight + extraGap && offset > 1) {
                    // WE HAVE PASSED THE HIDE AT ZONE (EG: 650PX AND > ).
                    if ($(".sr-logo-sticky").length > 0) {
                      $(".sr-logo-sticky").addClass("sr-logo-sticky-reveal");
                      $('.sr-header').removeClass("sr-logo-primary-reveal");
                    } else if ($("header.sr-logo-secondary-reveal").length > 0) {
                      $('.sr-header').addClass("sr-logo-primary-reveal");
                      $('.sr-header').removeClass("sr-logo-secondary-reveal");
                    }

                    if (!$(el).hasClass("sr_hidden") && hideonscroll) {
                      $(el).addClass("sr_hidden");
                    } else if (!hideonscroll) {
                      $(el).addClass("sr_sticky_showup");
                    }
                  }
                  if (lastScrollTop > st && !$(el).hasClass('sr_static')) {
                    //if we are scrolling to top
                    $(el).addClass("sr_sticky_showup");
                  }
                } else {
                  // WE ARE STILL IN THE NOHIDE ZONE (PROBABLY AROUND THE TOP OF WINDOW)
                  if ($(".sr-logo-sticky").length > 0) {
                    $(".sr-logo-sticky").removeClass("sr-logo-sticky-reveal");
                  }
                  if (
                    "secondary" ===
                    IRON.state.logo.page_logo_select_elementor &&
                    $('.sr-header').find(".sr-logo-secondary").length > 0
                  ) {
                    $('.sr-header').removeClass("sr-logo-primary-reveal");
                    $('.sr-header').addClass("sr-logo-secondary-reveal");
                  } else {
                    $('.sr-header').addClass("sr-logo-primary-reveal");
                  }

                  $(el).removeClass("sr_sticky_showup");
                  if (sticky[$(el).data('id')] !== undefined) {
                    setTimeout(function () {
                      sticky[$(el).data('id')].update(); //Reset sr_sticky_wrap height
                    }, 500);
                  }


                  if ($(el).hasClass("sr_hidden")) {
                    $(el).removeClass("sr_hidden");
                  }
                }
                if (lastScrollTop > st) {
                  // We are scrolling up
                  $(el).removeClass("sr_hidden");
                  if (offset <= hideAt && hideonscroll) {
                    $(el).removeClass("sr_sticky_showup");
                    if (sticky[$(el).data('id')] !== undefined) {
                      setTimeout(function () {
                        sticky[$(el).data('id')].update(); //Reset sr_sticky_wrap height
                      }, 500);
                    }

                  }
                } else {
                  // We scrolling down
                  if (offset > hideAt + elementHeight + extraGap && hideonscroll) {
                    $(el).addClass("sr_hidden");
                  }
                }

                lastScrollTop = st;
              });
            });

            if (this.getElementSettings("sr_sticky_offset")) {
            }
            var stickyID = this.$element.attr("data-id");
            var stickySelector = '[data-id="' + stickyID + '"]';
            sticky[stickyID] = new SRSticky(stickySelector, {});

            const wpadminbar = document.getElementById("wpadminbar");
            if (wpadminbar) {
              //var a = parseInt("32");
              var a = $("#wpadminbar").outerHeight();
              var b = parseInt(this.getElementSettings("sr_sticky_offset"));
              //this.$element.attr("data-margin-top", a+b);
              //this.$element.attr("data-margin-offset", b);
            } else {
              var a = 0;
              var b = parseInt(this.getElementSettings("sr_sticky_offset"));
            }
            this.$element.attr("data-margin-top", a + b);
            this.$element.attr("data-margin-offset", b);
            this.$element.attr("data-sticky-wrap", "true");
          } else {
            this.$element.removeClass("sr-sticky");
          }
        }
      },
    }); // end of section extends

    var handlersList = {
      section: SectionExtends,
    };

    $.each(handlersList, function (widgetName, handlerClass) {
      elementorFrontend.hooks.addAction(
        "frontend/element_ready/" + widgetName,
        function ($scope) {
          elementorFrontend.elementsHandler.addHandler(handlerClass, {
            $element: $scope,
          });
        }
      );
    });
  }); // end of elementor init

  // page init

  var MailChimp = function ($scope, $) {
    var $mailChimp = $scope.find(".sr-mailchimp-wrap").eq(0),
      $mailchimp_id =
        $mailChimp.data("mailchimp-id") !== undefined
          ? $mailChimp.data("mailchimp-id")
          : "",
      $api_key =
        $mailChimp.data("api-key") !== undefined
          ? $mailChimp.data("api-key")
          : "",
      $list_id =
        $mailChimp.data("list-id") !== undefined
          ? $mailChimp.data("list-id")
          : "",
      $button_text =
        $mailChimp.data("button-text") !== undefined
          ? $mailChimp.data("button-text")
          : "",
      $success_text =
        $mailChimp.data("success-text") !== undefined
          ? $mailChimp.data("success-text")
          : "",
      $loading_text =
        $mailChimp.data("loading-text") !== undefined
          ? $mailChimp.data("loading-text")
          : "";

    sr_mailchimp_subscribe(
      "sr-mailchimp-form-" + $mailchimp_id + "",
      $api_key,
      $list_id,
      $button_text,
      $success_text,
      $loading_text
    );
  };

  window.sr_mailchimp_subscribe = function (
    formId,
    apiKey,
    listId,
    buttonText,
    successMsg,
    loadingText
  ) {
    $("#" + formId).on("submit", function (e) {
      e.preventDefault();

      var self = $(this);

      self.find(".sr-mailchimp-subscribe").addClass("button--loading");
      self.find(".sr-mailchimp-subscribe span").html(loadingText);
      $.ajax({
        url: sonaarMailchimp.ajax_url,
        type: "POST",
        data: {
          action: "sr_mailchimp_subscribe",
          fields: self.serialize(),
          apiKey: apiKey,
          listId: listId,
        },
        success: function (data) {
          self
            .find(".sr-mailchimp-fields-wrapper")
            .after(
              '<div class="sr-mailchimp-message"><p>' +
              successMsg +
              "</p></div>"
            );
          self.find("input[type=text], input[type=email], textarea").val("");

          self.find(".sr-mailchimp-subscribe").removeClass("button--loading");
          self.find(".sr-mailchimp-subscribe span").html(buttonText);
        },
      });
    });
  };

  $(window).on("elementor/frontend/init", function () {
    //Apply in the Editor mode only

    if (elementorFrontend.isEditMode()) {
      isEditMode = true;

      //Load Music Player content in the Editor mode
      if (typeof IRON.isSonaarTheme !== "undefined" && IRON.isSonaarTheme) {//If Sonaar Theme is Enable
        elementorFrontend.hooks.addAction(
          "frontend/element_ready/music-player.default",
          function () {
            if (typeof setIronAudioplayers == "function") {
              setIronAudioplayers();
            }
          }
        );
      }

      //Load Podcast Player content in the Editor mode
      elementorFrontend.hooks.addAction(
        "frontend/element_ready/podcast-player.default",
        function () {
          if (typeof setIronAudioplayers == "function") {
            setIronAudioplayers();
          }
        }
      );

      //Load Event List content in the Editor mode
      elementorFrontend.hooks.addAction(
        "frontend/element_ready/event.default",
        function () {
          if (typeof IRON.eventList == "function") {
            IRON.eventList();
          }
        }
      );

      //Podcast Archive content in the Editor mode
      elementorFrontend.hooks.addAction(
        "frontend/element_ready/podcast-archive.default",
        function () {
          $(".sonaar-list").each(function () {
            var maxEpisode = $(this).data("item-per-page");
            $(this)
              .find(".sonaar-podcast-list-item")
              .each(function (index) {
                if (index >= maxEpisode) {
                  $(this).hide();
                }
              });
          });
        }
      );

      //Parallax Grid content in the Editor mode
      elementorFrontend.hooks.addAction(
        "frontend/element_ready/parallaxgrid.default",
        function () {
          if (typeof setIronAudioplayers == "function") {
            IRON.grid_column();
          }
        }
      );

      //Load MENU js script in the Editor mode
      elementorFrontend.hooks.addAction(
        "frontend/element_ready/sr-e-menu.default",
        function () {
          if (typeof IRON.setupElementorMenu == "function") {
            IRON.setupElementorMenu();
          }
        }
      );
    }

    elementorFrontend.hooks.addAction(
      "frontend/element_ready/sonaar-mailchimp.default",
      MailChimp
    );


    elementorFrontend.hooks.addAction(
      "frontend/element_ready/sr-offcanvas.default",
      function ($scope) {
        if (typeof sroffcanvas[canvasID] === "undefined" || canvasID != $scope) { // make sure to not load same canva twice ajax
          canvasID = $scope;
          sroffcanvas[canvasID] = new SrOffCanvasContent($scope);
        }
      }
    );

  });


  /*********************/
  /* ON RESIZE */
  /*********************/
  $(window).resize(function () {
    if ($(".elementor-widget-sr-e-menu").length > 0) {
      IRON.setupElementorMenu();
    }
    if ($('.sr-header').length > 0) {
      IRON.elementorHeaderLogo();
    }
  });
})(jQuery);

