(function ($) {

  let allToggleOffCanvasClass = []
  const closingDelay = 0.2; //Overlay animation: delay between content and background

  SrOffCanvasContent = function ($scope) {
    this.node = $scope;
    if ($scope.find(".sr-offcanvas-toggle").length < 1) return;

    this.wrap = $scope.find(".sr-offcanvas-content-wrap");
    this.content = $scope.find(".sr-offcanvas-content");
    this.button = $scope.find(".sr-offcanvas-toggle");
    this.settings = this.wrap.data("settings");
    this.id = this.settings.content_id;
    this.transition = this.settings.transition;
    this.time_transition = this.settings.time_transition;
    this.esc_close = this.settings.esc_close;
    this.body_click_close = this.settings.body_click_close;
    this.open_offcanvas = this.settings.open_offcanvas;
    this.direction = this.settings.direction;
    this.duration = 500;
    this.toggleOffCanvasClass = (this.settings.class_toggle_offCanvas.length)?'.' + this.settings.class_toggle_offCanvas: false;

    this.init();
  };

  SrOffCanvasContent.prototype = {
    id: "",
    node: "",
    wrap: "",
    content: "",
    button: "",
    settings: {},
    transition: "",
    duration: 400,
    initialized: false,
    animations: ["3dyatch", "slide", "reveal", "push", "overlay"],
    bodyScroll: 0,
    toggleOffCanvasClass: '',


    init: function () {
      if(this.toggleOffCanvasClass){
        allToggleOffCanvasClass.push(this.toggleOffCanvasClass);
      }

      $(this.toggleOffCanvasClass).css('cursor','pointer');
      
      $(".sr_sticky_wrap").prepend('<div class="sr_toggleSticky"></div>');
      if (!this.wrap.length) {
        return;
      }

      if ($(".sr-offcanvas-container").length === 0) {
        $("body").wrapInner(
          '<div class="sr-offcanvas-container" />'
        );
        this.content.insertBefore(".sr-offcanvas-container");
      }

      if (this.wrap.find(".sr-offcanvas-content").length > 0) {
        if (
          $(".sr-offcanvas-container > .sr-offcanvas-content-" + this.id)
            .length > 0
        ) {
          $(
            ".sr-offcanvas-container > .sr-offcanvas-content-" + this.id
          ).remove();
        }
        if ($("body > .sr-offcanvas-content-" + this.id).length > 0) {
          $("body > .sr-offcanvas-content-" + this.id).remove();
        }
        $("body").prepend(this.wrap.find(".sr-offcanvas-content"));

        //this.hideElementWithAnims();
      }

      this.bindEvents();
    },

    destroy: function () {
      this.close();

      this.animations.forEach(function (animation) {
        if ($("body").hasClass("sr-offcanvas-content-" + animation)) {
          $("body").removeClass("sr-offcanvas-content-" + animation);
        }
      });
    },

    bindEvents: function () {
      if (this.open_offcanvas === "yes") {
        this.show();
      }

      var self = this;
      this.button.on("click", function (e) {
        self.show();
      });
      if(this.toggleOffCanvasClass){
        $(this.toggleOffCanvasClass).on("click", function () {
          self.show();
        });
      }

      $("body").delegate(
        ".sr-offcanvas-content .sr-offcanvas-close",
        "click",
        $.proxy(this.close, this)
      );

      if (this.esc_close === "yes") {
        this.closeESC();
      }
      if (this.body_click_close === "yes") {
        this.closeClick();
      }
    },

    toggleContent: function () {
      if (!$("body").hasClass("sr-offcanvas-content-open")) {
        this.show();
      } else {
        this.close();
      }
    },
    restartCanvaAnim: function () {
      var $is_edit_mode = elementorFrontend.isEditMode();

      if ($is_edit_mode && typeof $invisibleRemoved === "undefined") {
        var animatedRows = this.content.find(".elementor-invisible"); // in editor, elementor put elementor-invisible class on the animated rows so we need to hack this.
      } else {
        var animatedRows = this.content.find(".animated");
      }

      animatedRows.each(function () {
        var $element = $(this);
        var timeout;
        var $animType = $element.data("settings")["_animation"];
        var $animDelay = $element.data("settings")["_animation_delay"] || 0;
        clearTimeout(timeout);
        $element.css("opacity", 0);
        $element.removeClass($animType);
        timeout = setTimeout(function () {
          if ($is_edit_mode) {
            $element.removeClass("elementor-invisible");
            $invisibleRemoved = true;
            $element.addClass("animated");
          }
          $element.addClass($animType);
          $element.css("opacity", 1);
        }, $animDelay);
      });
    },

    show: function () {
      if( $('.sr-offcanvas-content-' + this.id).hasClass('sr-closing') )
        return
  
      if (document.querySelector("#overlay") != null) {
        // #overlay doesnt exist when we edit an "header" post with the elementor editor
        var scrollbarWidth =
          document.querySelector("#overlay").offsetWidth -
          document.querySelector("body").offsetWidth;
      } else {
        var scrollbarWidth = 0;
      }
      var bodyScroll = $(document).scrollTop();

      $(
        ".sr-offcanvas-content-" + this.id + ", .sr-offcanvas-container"
      ).addClass("sr-offcanvas-content-visible");
      $(".sr-offcanvas-content-" + this.id).addClass("sr-offcanvas-opened");
      $("body").addClass("sr-offcanvas-content-" + this.direction);
      $("body").addClass("sr-offcanvas-content-open");
      $("body").addClass("sr-offcanvas-content-" + this.id + "-open");
      $("body").addClass("sr-offcanvas-content-reset");
      $("body").attr("sr-oc-transition", this.transition);
      if(this.transition == 'overlay'){
        $("body").attr("sr-oc-time-transition", this.time_transition);//Set in the Elementor Editor
      }else{
        $("body").attr("sr-oc-time-transition", this.duration);
      }
      $("body").attr("sr-oc-direction", this.direction);
      $("body").attr("sr-oc-id", this.id);
      this.restartCanvaAnim();

      $('.sr-offcanvas-content-' + this.id + '.sr-offcanvas-overlay .sr-offcanvas-body').css('transition-delay', this.time_transition * ( closingDelay + 0.2 ) + 'ms');

      if (this.transition == "3dyatch") {
        if ($("html").hasClass("wp-admin-bar")) {
          $("#wrapper").css("padding-top", "32px");
          if (bodyScroll > 32) {
            $("#pusher").scrollTop(bodyScroll);
          } else {
            $("#pusher").scrollTop(bodyScroll + 32);
          }
          $("header.sr-header").css("top", bodyScroll + 32);
        } else {
          $("#pusher").scrollTop(bodyScroll);

          $("header.sr-header").css("top", bodyScroll);
          if (scrollbarWidth) {
            $("#pusher").css("width", "calc(100% - " + scrollbarWidth + "px)");
          }
        }
        $("header.sr-header").prependTo("#pusher");

        if (scrollbarWidth) {
          $("#pusher").css("width", "calc(100% - " + scrollbarWidth + "px)");
        }
      }

      let canvasTimeTransition = Number(this.time_transition);
      let canvasID = this.id;
      $('.sr-offcanvas-content-' + canvasID).addClass('sr-opening');
      setTimeout(function () {
        $('.sr-offcanvas-content-' + canvasID).removeClass('sr-opening');
      }, canvasTimeTransition + (canvasTimeTransition * closingDelay) );
    },

    close: function () {
      if( $('.sr-offcanvas-content-' + this.id).hasClass('sr-opening') )
        return

      if (!$("body").find(".sr-offcanvas-opened").length) return;
      let canvasID = $("body").attr('sr-oc-id');
      let canvasDirection = $("body").attr('sr-oc-direction');
      let canvasTransition = $("body").attr('sr-oc-transition');
      let canvasTimeTransition = Number($("body").attr('sr-oc-time-transition'));
      let pusherScroll = $("#pusher").scrollTop();
      if (pusherScroll <= 32) {
        pusherScroll = 0;
      }
      
      $('body').removeAttr('sr-oc-direction');
      $('body').removeAttr('sr-oc-time-transition');
      $("body").removeClass("sr-offcanvas-content-open");
      $("body").removeClass("sr-offcanvas-content-" + canvasID + "-open");
      $(".sr-offcanvas-opened").removeClass("sr-offcanvas-opened");
      $('.sr-offcanvas-content-' + canvasID).addClass('sr-closing');

      $('.sr-offcanvas-content-' + this.id + '.sr-offcanvas-overlay').css('transition-delay', this.time_transition * closingDelay + 'ms');

      setTimeout(function () {
        $("body").removeClass("sr-offcanvas-content-reset");
        $("body").removeClass("sr-offcanvas-content-" + canvasDirection);
        $('body').removeAttr('sr-oc-transition');
        $(
          ".sr-offcanvas-content-" +
            canvasID +
            ", .sr-offcanvas-container"
        ).removeClass("sr-offcanvas-content-visible");
        $('body').removeAttr('sr-oc-id');
        $('.sr-offcanvas-content-' + canvasID).removeClass('sr-closing');
        if (canvasTransition == "3dyatch") {
          $("header.sr-header").insertAfter("#overlay");
          $("header.sr-header").css("top", "unset");
          $("#pusher").css("width", "100%");
          $("#wrapper").css("padding-top", "0px");
          $(document).scrollTop(pusherScroll);
        }
      }, canvasTimeTransition + (canvasTimeTransition * closingDelay) );
    },

    closeESC: function () {
      var self = this;

      if ("" === self.settings.esc_close) {
        return;
      }

      // menu close on ESC key
      $(document).on("keydown", function (e) {
        if (e.keyCode === 27) {
          // ESC
          self.close();
        }
      });
    },

    closeClick: function () {
      var self = this;
      $(window).on("click", function (e) {
        let sr_close = true;
        if (
          // DONT CLICK ON THE ITEMS BELOW
          $(e.target).is(".sr-offcanvas-content") ||
          $(e.target).parents(".sr-offcanvas-content").length > 0 ||
          $(e.target).is(".sr-offcanvas-toggle") ||
          $(e.target).parents(".sr-offcanvas-toggle").length > 0 
        ) {
          sr_close = false;
        } 
        $(allToggleOffCanvasClass).each(function () {
          if($(e.target).parents(String(this)).length > 0){
            sr_close = false;
          } 
        });
        if(sr_close){
          self.close();
        }
      });
    },
  };
})(jQuery);
