if (IRON === undefined) {
  var IRON = {};
}
if (IRON.state === undefined) {
  IRON.state = {};
  IRON.state.logo = {};
  IRON.state.logo.page_logo_select_elementor = null;
}
var sticky = [];

IRON.initEveryTime = function () {
  if (typeof sticky !== "undefined") {
    const SonaarResizeObserver = new ResizeObserver((entries) => {
      $(".sr-sticky").each(function () {
        var stickyID = $(this).attr("data-id");
        if ( typeof sticky[stickyID] != 'undefined' && sticky[stickyID].elements.length) {
          sticky[stickyID].onResizeEvents(sticky[stickyID].elements[0]);
        }
      });
    });
    // start observing a DOM node
    SonaarResizeObserver.observe(document.body);
  }
};
IRON.RemoveHrefFromMenu = function () {
  /* Remove link on ancestor item from responsive menu */
  if (
    (!iron_vars.menu.unveil_all_mobile_items &&
      ($(".responsive-header").length || $(".side-menu").length)) ||
    $(".sr-e-menu.sr-menu--vertical").length
  ) {
    if ($(".sr-e-menu.sr-menu--vertical").length) {
      $(".sr-e-menu.sr-menu--vertical .menu-item-has-children>a").attr(
        "href",
        "#"
      );
    } else {
      $(".menu-item-has-children>a").attr("href", "#");
    }
  }
};
IRON.setupElementorMenu = function () {
  //To apply the margin of the current sticky item.
  $(".sr-e-menu-toggle")
    .off()
    .on("click", function (e) {
      $(this).toggleClass("sr-toggle-active");
    });

  //Set Stretch Menu mobile
  $(".sr-e-menu--stretch .sr-e-mobile").each(function () {
    var sr_menuPosition = this.getBoundingClientRect();
    var currentLeft = parseInt($(this).css("left"), 10);
    if (isNaN(currentLeft)) {
      currentLeft = 0;
    }
    sr_menuPosition = -1 * sr_menuPosition.left + currentLeft + "px";
    $(this).css("left", sr_menuPosition);
    $(this).css("top", $(".sr-e-menu-toggle").outerHeight());
  });

  $(".sr-e-menu.sr-menu--vertical li a")
    .off()
    .on("click", function (e) {
      // toggle in all case active class
      var anchor = $(this);
      var anchorParents = anchor.parents("li");

      $(this)
        .parents(".sr-e-menu")
        .find("li")
        .each(function (el) {
          if (!_.contains(anchorParents, this)) {
            $(this).removeClass("active");
          }
        });

      $(this).closest("li").toggleClass("active");

      if (
        $(this).attr("href") === "#" ||
        $(this).closest("li").hasClass("menu-item-has-children")
      ) {
        //prevent
        e.preventDefault();
      } else {
        $(".sr-e-menu.sr-menu--vertical").removeClass("visible");
        $(".sr-e-menu.sr-menu--vertical").scrollTop(0);
      }
    });

  // Let close the offcanva when clicking on an item with a # href EXCEPT if ahref has children
  $('.sr-offcanvas-content a[href*="#"]').click(function () {
    if ($(this).parents(".menu-item-has-children").length) return;

    $(window).trigger("click");
  });

  // Let close the toggle menu when clicking on an item with a # href EXCEPT if ahref has children
  $('.sr-e-menu--toggle .sr-e-mobile a[href*="#"]').click(function () {
    if ($(this).parents(".menu-item-has-children").length) return;

    IRON.toggleElementorMenuClose();
  });
  // Collision: avoid submenu to be out of viewport.
  $(".sr-e-menu ul")
    .find(">li a")
    .on("mouseover", function (e) {
      // check if has submenu
      if ($(this).find(" + ul").length > 0) {
        var $_this = $(this).find(" + ul");
        if (
          $_this.outerWidth(true) + $_this.offset().left >
          $(window).width()
        ) {
          $(this).parent().addClass("collision");
        }
      }
    });
  // Close Submenu when we navigate
  $(".sr-header .sub-menu a").on("click", function () {
    $(".sr-header .menu-item").css("pointer-events", "none");
    setTimeout(function () {
      $(".sr-header .menu-item").css("pointer-events", "auto");
    }, 100);
  });

  //Elementor PRo editor "Edit Header" button hide and show
  $(
    ".elementor-html .sr-over-content #wrapper .elementor-section-wrap>section:first-of-type"
  ).on({
    mouseenter: function () {
      $(".sr-header>.elementor").addClass("sr-elementor-focus");
    },
    mouseleave: function () {
      $(".sr-header>.elementor").removeClass("sr-elementor-focus");
    },
  });

  //Elementor Editor - Header device label link
  $('html.elementor-html .single-block section, html.elementor-html header .elementor-section').each(function () {
    let sr_deviceButton = '<div class="sr-device-label"><span class="sr-device-link sr-mobile-link">Mobile</span><span class="sr-seperator-1"> + </span><span class="sr-tablet-link sr-device-link">Tablet</span><span class="sr-seperator-2"> + </span><span class="sr-desktop-link sr-device-link">Desktop</span><span> Version</span></div>';
    if (!$(this).find('.sr-device-label').length) {
      $(this).append(sr_deviceButton);
    }
  });

  $('.sr-mobile-link').on('click', function () {
    elementor.changeDeviceMode('mobile');
  })
  $('.sr-tablet-link').on('click', function () {
    elementor.changeDeviceMode('tablet');
  })
  $('.sr-desktop-link').on('click', function () {
    elementor.changeDeviceMode('desktop');
  })
};

IRON.toggleElementorMenuClose = function () {
  if (!$(".sr-toggle-active").length) return;

  $(".sr-e-menu-toggle").removeClass("sr-toggle-active");
};

IRON.elementorHeaderLogo = function () { //Sonaar Theme only
  if ($('.sr-header').find(".sr-logo-secondary").length < 1) {
    $('.sr-header').addClass("sr-logo-primary-reveal");
    return;
  }

  $('.sr-header').addClass("sr-logo-reveal");
  if (
    "secondary" === IRON.state.logo.page_logo_select_elementor &&
    $('.sr-header').find(".sr-logo-secondary").length > 0
  ) {
    $('.sr-header').addClass("sr-logo-secondary-selected");
  } else {
    $('.sr-header').removeClass("sr-logo-secondary-selected");
  }
};


(function ($) {
  "use strict";
  var sroffcanvas = [];
  var canvasID;
  var isEditMode = false;

  $(window).on("elementor/frontend/init", function () {
    jQuery(sticky).each(function () {
      if (typeof this !== "undefined") {
        this.destroy();
      }
    });
    sticky = [];

    IRON.setupElementorMenu();

    setTimeout(function () {
      window.dispatchEvent(new Event("resize"));
    }, 100);

    var SectionExtends = elementorModules.frontend.handlers.Base.extend({
      onInit: function onInit() {
        elementorModules.frontend.handlers.Base.prototype.onInit.apply(
          this,
          arguments
        );
        this.initSectionExtends();
      },
      isSrSticky: function () {
        return this.$element.hasClass("sr-sticky");
      },

      onElementChange: function (changedProp) {
        if (changedProp === "sr_sticky") {
          if ("" !== this.getElementSettings("sr_sticky")) {
            //this.$element.addClass( 'sr-sticky' );
          } else {
            this.$element.removeClass("sr-sticky");
            var stickyElement = sticky[this.$element.attr("data-id")];
            window.removeEventListener(
              "load",
              stickyElement.updateScrollTopPosition
            );
            window.removeEventListener(
              "scroll",
              stickyElement.updateScrollTopPosition
            );
          }
        }
      },
      initSectionExtends: function () {
        if (typeof this.getElementSettings("sr_sticky_on") !== "undefined") {
          var currentDeviceMode = elementorFrontend.getCurrentDeviceMode();
          var activeDevices = this.getElementSettings("sr_sticky_on");

          if (-1 !== activeDevices.indexOf(currentDeviceMode)) {
            this.$element.addClass("sr-sticky");

            var stickyOffset = this.getElementSettings("sr_sticky_offset");
            var hideAfter = this.getElementSettings("sr_hide_after");

            if (1 == this.getElementSettings("sr_sticky_hideonscroll")) {
              // HIDE THE STICKY AFTER SCROLL
              var hideonscroll = true;
            } else {
              // DONT HIDE THE STICKY AFTER SCROLL
              var hideonscroll = false;
            }

            this.$element.each(function () {
              var el = this;
              var lastScrollTop = 0;
              var extraGap = 0;
              if (hideonscroll) {
                var elementHeight = el.offsetHeight;//When the hideonscroll option is enable, the sticky element only stick on scrollup
                extraGap = globalExtraGap || 0;
                hideAfter = 0;
              } else {
                var elementHeight = 0;
              }
              var hideAt = $(el).offset().top + hideAfter - stickyOffset; // make sure hideAt is 0 if dont hide the sticky

              $(el).addClass("sr_hideOnScroll");
              $(document).on("scroll touchmove", function (e) {
                var offset = $(this).scrollTop();
                var st = $(this).scrollTop();
                if (offset > hideAt + elementHeight) {
                  if (offset > hideAt + elementHeight + extraGap && offset > 1) {
                    // WE HAVE PASSED THE HIDE AT ZONE (EG: 650PX AND > ).
                    if ($(".sr-logo-sticky").length > 0) {
                      $(".sr-logo-sticky").addClass("sr-logo-sticky-reveal");
                      $('.sr-header').removeClass("sr-logo-primary-reveal");
                    } else if ($("header.sr-logo-secondary-reveal").length > 0) {
                      $('.sr-header').addClass("sr-logo-primary-reveal");
                      $('.sr-header').removeClass("sr-logo-secondary-reveal");
                    }

                    if (!$(el).hasClass("sr_hidden") && hideonscroll) {
                      $(el).addClass("sr_hidden");
                    } else if (!hideonscroll) {
                      $(el).addClass("sr_sticky_showup");
                    }
                  }
                  if (lastScrollTop > st && !$(el).hasClass('sr_static')) {
                    //if we are scrolling to top
                    $(el).addClass("sr_sticky_showup");
                  }
                } else {
                  // WE ARE STILL IN THE NOHIDE ZONE (PROBABLY AROUND THE TOP OF WINDOW)
                  if ($(".sr-logo-sticky").length > 0) {
                    $(".sr-logo-sticky").removeClass("sr-logo-sticky-reveal");
                  }
                  if (
                    "secondary" ===
                    IRON.state.logo.page_logo_select_elementor &&
                    $('.sr-header').find(".sr-logo-secondary").length > 0
                  ) {
                    $('.sr-header').removeClass("sr-logo-primary-reveal");
                    $('.sr-header').addClass("sr-logo-secondary-reveal");
                  } else {
                    $('.sr-header').addClass("sr-logo-primary-reveal");
                  }

                  $(el).removeClass("sr_sticky_showup");
                  if (sticky[$(el).data('id')] !== undefined) {
                    setTimeout(function () {
                      sticky[$(el).data('id')].update(); //Reset sr_sticky_wrap height
                    }, 500);
                  }


                  if ($(el).hasClass("sr_hidden")) {
                    $(el).removeClass("sr_hidden");
                  }
                }
                if (lastScrollTop > st) {
                  // We are scrolling up
                  $(el).removeClass("sr_hidden");
                  if (offset <= hideAt && hideonscroll) {
                    $(el).removeClass("sr_sticky_showup");
                    if (sticky[$(el).data('id')] !== undefined) {
                      setTimeout(function () {
                        sticky[$(el).data('id')].update(); //Reset sr_sticky_wrap height
                      }, 500);
                    }

                  }
                } else {
                  // We scrolling down
                  if (offset > hideAt + elementHeight + extraGap && hideonscroll) {
                    $(el).addClass("sr_hidden");
                  }
                }

                lastScrollTop = st;
              });
            });

            if (this.getElementSettings("sr_sticky_offset")) {
            }
            var stickyID = this.$element.attr("data-id");
            var stickySelector = '[data-id="' + stickyID + '"]';
            sticky[stickyID] = new SRSticky(stickySelector, {});

            const wpadminbar = document.getElementById("wpadminbar");
            if (wpadminbar) {
              //var a = parseInt("32");
              var a = $("#wpadminbar").outerHeight();
              var b = parseInt(this.getElementSettings("sr_sticky_offset"));
              //this.$element.attr("data-margin-top", a+b);
              //this.$element.attr("data-margin-offset", b);
            } else {
              var a = 0;
              var b = parseInt(this.getElementSettings("sr_sticky_offset"));
            }
            this.$element.attr("data-margin-top", a + b);
            this.$element.attr("data-margin-offset", b);
            this.$element.attr("data-sticky-wrap", "true");
          } else {
            this.$element.removeClass("sr-sticky");
          }
        }
      },
    }); // end of section extends

    var handlersList = {
      section: SectionExtends,
    };

    $.each(handlersList, function (widgetName, handlerClass) {
      elementorFrontend.hooks.addAction(
        "frontend/element_ready/" + widgetName,
        function ($scope) {
          elementorFrontend.elementsHandler.addHandler(handlerClass, {
            $element: $scope,
          });
        }
      );
    });
  }); // end of elementor init

  // page init

  var MailChimp = function ($scope, $) {
    var $mailChimp = $scope.find(".sr-mailchimp-wrap").eq(0),
      $mailchimp_id =
        $mailChimp.data("mailchimp-id") !== undefined
          ? $mailChimp.data("mailchimp-id")
          : "",
      $api_key =
        $mailChimp.data("api-key") !== undefined
          ? $mailChimp.data("api-key")
          : "",
      $list_id =
        $mailChimp.data("list-id") !== undefined
          ? $mailChimp.data("list-id")
          : "",
      $button_text =
        $mailChimp.data("button-text") !== undefined
          ? $mailChimp.data("button-text")
          : "",
      $success_text =
        $mailChimp.data("success-text") !== undefined
          ? $mailChimp.data("success-text")
          : "",
      $loading_text =
        $mailChimp.data("loading-text") !== undefined
          ? $mailChimp.data("loading-text")
          : "";

    sr_mailchimp_subscribe(
      "sr-mailchimp-form-" + $mailchimp_id + "",
      $api_key,
      $list_id,
      $button_text,
      $success_text,
      $loading_text
    );
  };

  window.sr_mailchimp_subscribe = function (
    formId,
    apiKey,
    listId,
    buttonText,
    successMsg,
    loadingText
  ) {
    $("#" + formId).on("submit", function (e) {
      e.preventDefault();

      var self = $(this);

      self.find(".sr-mailchimp-subscribe").addClass("button--loading");
      self.find(".sr-mailchimp-subscribe span").html(loadingText);
      $.ajax({
        url: sonaarMailchimp.ajax_url,
        type: "POST",
        data: {
          action: "sr_mailchimp_subscribe",
          fields: self.serialize(),
          apiKey: apiKey,
          listId: listId,
        },
        success: function (data) {
          self
            .find(".sr-mailchimp-fields-wrapper")
            .after(
              '<div class="sr-mailchimp-message"><p>' +
              successMsg +
              "</p></div>"
            );
          self.find("input[type=text], input[type=email], textarea").val("");

          self.find(".sr-mailchimp-subscribe").removeClass("button--loading");
          self.find(".sr-mailchimp-subscribe span").html(buttonText);
        },
      });
    });
  };

  $(window).on("elementor/frontend/init", function () {
    //Apply in the Editor mode only

    if (elementorFrontend.isEditMode()) {
      isEditMode = true;

      //Load Music Player content in the Editor mode
      if (typeof IRON.isSonaarTheme !== "undefined" && IRON.isSonaarTheme) {//If Sonaar Theme is Enable
        elementorFrontend.hooks.addAction(
          "frontend/element_ready/music-player.default",
          function () {
            if (typeof setIronAudioplayers == "function") {
              setIronAudioplayers();
            }
          }
        );
      }

      //Load Podcast Player content in the Editor mode
      elementorFrontend.hooks.addAction(
        "frontend/element_ready/podcast-player.default",
        function () {
          if (typeof setIronAudioplayers == "function") {
            setIronAudioplayers();
          }
        }
      );

      //Load Event List content in the Editor mode
      elementorFrontend.hooks.addAction(
        "frontend/element_ready/event.default",
        function () {
          if (typeof IRON.eventList == "function") {
            IRON.eventList();
          }
        }
      );

      //Podcast Archive content in the Editor mode
      elementorFrontend.hooks.addAction(
        "frontend/element_ready/podcast-archive.default",
        function () {
          $(".sonaar-list").each(function () {
            var maxEpisode = $(this).data("item-per-page");
            $(this)
              .find(".sonaar-podcast-list-item")
              .each(function (index) {
                if (index >= maxEpisode) {
                  $(this).hide();
                }
              });
          });
        }
      );

      //Parallax Grid content in the Editor mode
      elementorFrontend.hooks.addAction(
        "frontend/element_ready/parallaxgrid.default",
        function () {
          if (typeof setIronAudioplayers == "function") {
            IRON.grid_column();
          }
        }
      );

      //Load MENU js script in the Editor mode
      elementorFrontend.hooks.addAction(
        "frontend/element_ready/sr-e-menu.default",
        function () {
          if (typeof IRON.setupElementorMenu == "function") {
            IRON.setupElementorMenu();
          }
        }
      );
    }

    elementorFrontend.hooks.addAction(
      "frontend/element_ready/sonaar-mailchimp.default",
      MailChimp
    );


    elementorFrontend.hooks.addAction(
      "frontend/element_ready/sr-offcanvas.default",
      function ($scope) {
        if (typeof sroffcanvas[canvasID] === "undefined" || canvasID != $scope) { // make sure to not load same canva twice ajax
          canvasID = $scope;
          sroffcanvas[canvasID] = new SrOffCanvasContent($scope);
        }
      }
    );

  });


  /*********************/
  /* ON RESIZE */
  /*********************/
  $(window).resize(function () {
    if ($(".elementor-widget-sr-e-menu").length > 0) {
      IRON.setupElementorMenu();
    }
    if ($('.sr-header').length > 0) {
      IRON.elementorHeaderLogo();
    }
  });
})(jQuery);

