<?php


    // Get all WordPress registered widgets
   /* function sr_get_registered_sidebars()
    {
        global $wp_registered_sidebars;
        $options = [];

        if (!$wp_registered_sidebars) {
            $options[''] = __('No sidebars were found', 'elementor-sonaar');
        } else {
            $options['---'] = __('Choose Sidebar', 'elementor-sonaar');

            foreach ($wp_registered_sidebars as $sidebar_id => $sidebar) {
                $options[$sidebar_id] = $sidebar['name'];
            }
        }
        return $options;
    }*/



    /**
     * Get all elementor page templates
     *
     * @param  null  $type
     *
     * @return array
     */
    function sr_get_elementor_templates($type = null)
    {
        $options = [];

        if ($type) {
            $args = [
                'post_type' => 'elementor_library',
                'posts_per_page' => -1,
            ];
            $args['tax_query'] = [
                [
                    'taxonomy' => 'elementor_library_type',
                    'field' => 'slug',
                    'terms' => $type,
                ],
            ];

            $page_templates = get_posts($args);

            if (!empty($page_templates) && !is_wp_error($page_templates)) {
                $options[-1] = __('- Select -', 'elementor-sonaar');
                foreach ($page_templates as $post) {
                    $options[$post->ID] = $post->post_title;
                }
            }else{
                $options[-1] = __('No saved templates found!', 'elementor-sonaar');
            }
            
        } else {
            $options = "error";
        }

        return $options;
    }


   /* function sr_get_template_options($type = ''){
        $page_templates = get_elementor_templates($type);

        $options[-1] = __('Select', 'elementor-sonaar');

        if (count($page_templates)) {
            foreach ($page_templates as $id => $name) {
                $options[$id] = $name;
            }
        } else {
            $options['no_template'] = __('No saved templates found!', 'elementor-sonaar');
        }

        return $options;
    }*/
/**
 * Get Artist List
 */
    function sr_elementor_select_events_for(){
        $sr_artist_list = get_posts(array(
            'post_type' => 'artist',
            'posts_per_page' => 999,
        ));
        $options = array();
       // $options[0] = esc_html__( '-- Select Artist --', 'elementor-sonaar' );
        if ( ! empty( $sr_artist_list ) && ! is_wp_error( $sr_artist_list ) ){
            foreach ( $sr_artist_list as $post ) {
                $options[ $post->ID ] = $post->post_title;
            }
        } else {
            $options[0] = esc_html__( 'Create an artist first', 'elementor-sonaar' );
        }
        return $options;
    }

/**
 * Get Podcast Category
 */

function sr_elementor_select_category($taxonomy){
    $args = array(
        'taxonomy'=> $taxonomy
    );

    $sr_category_list = get_terms( $args );
    $options = array();
    if ( ! empty( $sr_category_list ) && ! is_wp_error( $sr_category_list ) ){
        foreach ( $sr_category_list as $category ) {
            $options[ $category->term_id] = $category->name;
        }
    } else {
        $options[0] = esc_html__( 'Create an Category First', 'elementor-sonaar' );
    }
    return $options;
}


/**
 * Get Podcast Episode
 */

    function sr_elementor_select_episode(){
        $sr_episode_list = get_posts(array(
            'post_type' => 'podcast',
            'posts_per_page' => 999,
        ));
        $options = array();
        $options[0] = esc_html__( '-- Play Last Published Episode --', 'elementor-sonaar' );
        if ( ! empty( $sr_episode_list ) && ! is_wp_error( $sr_episode_list ) ){
            foreach ( $sr_episode_list as $post ) {
                $options[ $post->ID ] = $post->post_title;
            }
        } else {
            $options[0] = esc_html__( 'Create an Episode First', 'elementor-sonaar' );
        }
        return $options;
    }

/**
 * Get Latest Published Post
 */
    function sr_elementor_getLatestPost($posttype){
        $arg = wp_get_recent_posts(array('post_type'=>$posttype, 'post_status' => 'publish', 'numberposts' => 1));
        if (!empty($arg)){
            return $arg[0]["ID"];
            //$albums = $recent_posts[0]["ID"];
        }
    }

    /**
 * Get Podcast Episode from a elementor Button
 */

    function sr_elementor_select_episode_from_button(){
        $sr_episode_list = get_posts(array(
            'post_type' => 'podcast',
            'posts_per_page' => 999,
        ));
        $options = array();
        $options[0] = esc_html__( '-- Select an Episode --', 'elementor-sonaar' );
        if ( ! empty( $sr_episode_list ) && ! is_wp_error( $sr_episode_list ) ){
            foreach ( $sr_episode_list as $post ) {
                $options[ $post->ID ] = $post->post_title;
            }
        } else {
            $options[0] = esc_html__( 'Create an Episode First', 'elementor-sonaar' );
        }

        return $options;
    }
/**
 * Get Artist
 */

    function sr_elementor_select_artist(){
        $sr_artist_list = get_posts(array(
            'post_type' => 'artist',
            'posts_per_page' => 999,
        ));
        $options = array();

        if ( ! empty( $sr_artist_list ) && ! is_wp_error( $sr_artist_list ) ){
            foreach ( $sr_artist_list as $post ) {
                $options[ $post->ID ] = $post->post_title;
            }
        } else {
            $options[0] = esc_html__( 'Create an Artist First', 'elementor-sonaar' );
        }
        return $options;
    }

/**
 * Get Music Playlist
 */

function sr_elementor_select_playlist($postType = 'album'){
    $sr_playlist_list = get_posts(array(
        'post_type' => $postType,
        'posts_per_page' => 999,
    ));
    $options = array();

    if ( ! empty( $sr_playlist_list ) && ! is_wp_error( $sr_playlist_list ) ){
        foreach ( $sr_playlist_list as $post ) {
            $options[ $post->ID ] = $post->post_title;
        }
    } else {
        $options[0] = esc_html__( 'Create a Playlist First', 'elementor-sonaar' );
    }
    return $options;
}

/**
 * Get Video posts
 */
function sr_elementor_select_video(){
    $sr_video_list = get_posts(array(
        'post_type' => 'video',
        'posts_per_page' => 999,
    ));
    $options = array();

    if ( ! empty( $sr_video_list ) && ! is_wp_error( $sr_video_list ) ){
        foreach ( $sr_video_list as $post ) {
            $options[ $post->ID ] = $post->post_title;
        }
    } else {
        $options[0] = esc_html__( 'Create a Video Post First', 'elementor-sonaar' );
    }
    return $options;
}
/**
 * Get Sliders
 */
    function sr_elementor_select_slider(){
        $slider = new RevSlider();
        $arrSliders = $slider->getArrSliders();
        $revsliders = array();
        if ( $arrSliders ) {
            foreach ( $arrSliders as $slider ) {
                /** @var $slider RevSlider */
                $revsliders[ $slider->getAlias() ] = $slider->getTitle();
            }
        } else {
            $revsliders[0]= esc_html__( 'No Slider Exists. Please create one', 'elementor-sonaar' );
        }
        return $revsliders;
   }
   /**
 * Get Ess Grid
 */
    function sr_elementor_select_essgrid(){
        if ( class_exists('Essential_Grid')){
         $grids = Essential_Grid::get_grids_short_vc();
        }
        $essgrid = array();
        if(!empty($grids)){
            foreach($grids as $title => $alias){
                $essgrid[$alias] = $title;

            }

        } else {
            $essgrid[0]= esc_html__( 'No Grid Exists. Please create one', 'elementor-sonaar' );
        }

        return $essgrid;

   }
/**
 * Get Contact Form 7 [ if exists ]
 */
if ( function_exists( 'wpcf7' ) ) {
    function sr_elementor_select_wpcf7(){
        $wpcf7_form_list = get_posts(array(
            'post_type' => 'wpcf7_contact_form',
            'posts_per_page' => 999,
        ));
        $options = array();
        $options[0] = esc_html__( 'Select a Contact Form', 'elementor-sonaar' );
        if ( ! empty( $wpcf7_form_list ) && ! is_wp_error( $wpcf7_form_list ) ){
            foreach ( $wpcf7_form_list as $post ) {
                $options[ $post->ID ] = $post->post_title;
            }
        } else {
            $options[0] = esc_html__( 'Create a Form First', 'elementor-sonaar' );
        }
        return $options;
    }
}
