<?php
namespace Elementor;
if ( ! defined( 'ABSPATH' ) ) exit; // Exit if accessed directly

use Elementor\Widget_Base;
use Elementor\Controls_Manager;
use Elementor\Group_Control_Base;
use Elementor\Group_Control_Background;
use Elementor\Group_Control_Typography;
use Elementor\Core\Schemes\Typography;

/**
 * Elementor Hello World
 *
 * Elementor widget for hello world.
 *
 * @since 1.0.0
 */

class SR_BeatStars_Player extends Widget_Base {

	public function get_name() {
		return 'beatstars_player';
	}

	public function get_title() {
		return __( 'BeatStars Store', 'elementor-sonaar' );
	}

	public function get_icon() {
		return 'fas fa-cart-arrow-down sonaar-badge';
	}
	public function get_help_url() {
		return 'https://support.sonaar.io';
	}
	public function get_categories() {
		return [ 'elementor-sonaar' ];
	}

	public function get_script_depends() {
		return [ 'elementor-sonaar' ];
	}
	public function get_keywords() {
		return [ 'beatstar', 'sonaar'];
	}
	protected function register_controls() {
		$this->start_controls_section(
			'section_content',
			[
				'label' => __( 'BeatStars Player Settings', 'elementor-sonaar' ),
			]
		);
				$this->add_control(
					'player_id',
					[
						'label' => __( 'Player ID', 'elementor-sonaar' ),
						'type' => \Elementor\Controls_Manager::TEXT,
						'placeholder' => __( 'Enter the ID of your player', 'elementor-sonaar' ),
						'default' => "97062",
					]
				);
				$this->add_control(
					'important_note',
					[
						'label' => __( 'Message', 'elementor-sonaar' ),
						'show_label' => false,
						'type' => \Elementor\Controls_Manager::RAW_HTML,
						'raw' => __( '<br>To get your BeatStars Player ID, see this <a href="https://d.pr/i/zU5aHu" target="_blank">screenshot</a>', 'elementor-sonaar' ),
						'content_classes' => 'elementor-sonaar-raw-html',
					]
				);
				$this->add_control(
					'player_height',
					[
						'label' => __( 'Player height', 'elementor-sonaar' ),
						'type' => \Elementor\Controls_Manager::TEXT,
						'placeholder' => __( 'Enter the height dimension of your player', 'elementor-sonaar' ),
						'default' => "600",
					]
				);

		$this->end_controls_section();
	}

	protected function render() {
		$settings = $this->get_settings_for_display();
		$shortcode = '<iframe src="https://player.beatstars.com/?storeId=' . $settings['player_id'] . '"scrolling="no" width="100%" height="' . $settings['player_height'] . '" style="max-width:1230px;"frameborder="0" marginheight="0" marginwidth="0"> -- none -- </iframe>';
		
		echo ( $shortcode );
	}
	public function render_plain_content() {
		$settings = $this->get_settings_for_display();
		$shortcode = '<iframe src="https://player.beatstars.com/?storeId' . $settings['player_id'] . '"scrolling="no" width="100%" height="' . $settings['player_height'] . '" style="max-width:1230px;"frameborder="0" marginheight="0" marginwidth="0"> -- none -- </iframe>';
		
		echo ( $shortcode );
	}
	

	
}
Plugin::instance()->widgets_manager->register( new SR_BeatStars_Player() );