<?php
namespace Elementor;
if ( ! defined( 'ABSPATH' ) ) exit; // Exit if accessed directly

use Elementor\Widget_Base;
use Elementor\Controls_Manager;


/**
 * Elementor Hello World
 *
 * Elementor widget for hello world.
 *
 * @since 1.0.0
 */

class SR_ButtonPlayer {

	
	/*public function __construct() {
		parent::__construct();
		$this->init_control();
	}*/

	public function get_name() {
		return 'sr-buttonplayer';
	}

	public static function register_controls(Element_Base $element) {

		$element->start_controls_section(
			'sr_buttonplayer_section',
			[
				'label' => sprintf('<i class="sricons-logo"></i>&nbsp;  %s', __('Launch the Audio Player', 'elementor-sonaar')),
				
			]
		);
		$element->add_control(
			'play_current_id',
			[
				'label' => __( 'Play its own Post ID track', 'elementor-sonaar' ),
				'description' => __( 'Check this case if this player is intended to be displayed on its own post ID', 'elementor-sonaar' ),
				'type' => \Elementor\Controls_Manager::SWITCHER,
				'yes' => __( 'Yes', 'elementor-sonaar' ),
				'no' => __( 'No', 'elementor-sonaar' ),
				'return_value' => 'yes',
				'default' => '',

			]
		);
		$element->add_control(
			'sr_music_cpt_toggle',
			[
				'label' => __( 'Launch a Music Playlist', 'elementor-sonaar' ),
				'type' => \Elementor\Controls_Manager::SWITCHER,
				'default' => '',
				'label_on' => 'Yes',
				'label_off' => 'No',
				'return_value' => 'yes',
				'condition' => ['sr_podcast_cpt_toggle' => '','play_current_id!' => 'yes',],
			]
		);
		$element->add_control(
			'sr_music_cpt_getlatest',
			[
				'label' => __( 'Play Most Recent Playlist', 'elementor-sonaar' ),
				'type' => \Elementor\Controls_Manager::SWITCHER,
				'default' => '',
				'label_on' => 'Yes',
				'label_off' => 'No',
				'return_value' => 'yes',
				'condition' => ['sr_podcast_cpt_toggle' => '','sr_music_cpt_toggle' => 'yes','play_current_id!' => 'yes',],
			]
		);
		$element->add_control(
			'playlist_list',
				[
					'label'                 => esc_html__( 'Select Playlist(s)', 'elementor-sonaar' ),
					'label_block' => true,
					'type' => \Elementor\Controls_Manager::SELECT,
					'multiple' => true,
					'options'               => sr_elementor_select_playlist(),            	
					'condition' => ['sr_music_cpt_toggle' => 'yes','play_current_id!' => 'yes', 'sr_music_cpt_getlatest!' => 'yes'],
				]
		);
		$element->add_control(
			'sr_podcast_cpt_toggle',
			[
				'label' => __( 'Launch a Podcast Player', 'elementor-sonaar' ),
				'type' => \Elementor\Controls_Manager::SWITCHER,
				'default' => '',
				'label_on' => 'Yes',
				'label_off' => 'No',
				'return_value' => 'yes',
				'condition' => ['sr_music_cpt_toggle' => '','play_current_id!' => 'yes',],
			]
		);
		$element->add_control(
			'sr_podcast_cpt_getlatest',
			[
				'label' => __( 'Play Most Recent Episode', 'elementor-sonaar' ),
				'type' => \Elementor\Controls_Manager::SWITCHER,
				'default' => '',
				'label_on' => 'Yes',
				'label_off' => 'No',
				'return_value' => 'yes',
				'condition' => ['sr_music_cpt_toggle' => '','sr_podcast_cpt_toggle' => 'yes','play_current_id!' => 'yes',],
			]
		);
		$element->add_control(
			'episode_list',
				[
					'label'                 => esc_html__( 'Select Episode', 'elementor-sonaar' ),
					'type'                  => Controls_Manager::SELECT,
					'label_block'           => true,
					'options'               => sr_elementor_select_episode_from_button(),
	                'default'               => '0',
	                'condition' => ['sr_podcast_cpt_toggle' => 'yes','play_current_id!' => 'yes', 'sr_podcast_cpt_getlatest!' => 'yes'],
	               				             	
				]
		);

		$element->end_controls_section();

		}

		public static function renderfnc($button) {

			 if( 'button' === $button->get_name() ) {
			    // Get the settings
			    $settings = $button->get_settings();

			    if( $settings['play_current_id'] =="yes" ) {
				    	$postid = get_the_ID();
				    	$display_playlist_ar = $postid;
				    	$audiocall = "javascript:IRON.sonaar.player.setPlayer({id:" . $display_playlist_ar . "})";
						$button->add_render_attribute( 'button', 'href', $audiocall, true );
				    	return;
				}
			    if( $settings['sr_music_cpt_toggle'] =="yes" ) {
			    	if($settings['sr_music_cpt_getlatest'] != 'yes' && $settings['playlist_list']){
			    		$display_playlist_ar = $settings['playlist_list'];
			    	}else{
			    		$display_playlist_ar = sr_elementor_getLatestPost('album');
			    	}
					$audiocall = "javascript:IRON.sonaar.player.setPlayer({id:" . $display_playlist_ar . "})";
					$button->add_render_attribute( 'button', 'href', $audiocall, true );
			    }

			    if( $settings['sr_podcast_cpt_toggle'] =="yes") {
					if($settings['sr_podcast_cpt_getlatest'] != 'yes' && $settings['episode_list']){
						$display_playlist_ar = $settings['episode_list'];
					}else{
						$display_playlist_ar = sr_elementor_getLatestPost('podcast');
				   	}
				   	$audiocall = "javascript:IRON.sonaar.player.setPlayer({id:" . $display_playlist_ar . "})";
					$button->add_render_attribute( 'button', 'href', $audiocall, true );
			    }
			    
			  }
		}
		
		public static function init_control() {
			add_action( 'elementor/element/button/section_button/after_section_end',  [  __CLASS__, 'register_controls' ] );
			add_action( 'elementor/widget/before_render_content', [  __CLASS__, 'renderfnc' ] );

		}
	}
SR_ButtonPlayer::init_control();
//Plugin::instance(new SR_ButtonPlayer() );