<?php
namespace Elementor;
if ( ! defined( 'ABSPATH' ) ) exit; // Exit if accessed directly

use Elementor\Widget_Base;
use Elementor\Controls_Manager;

/**
 * Elementor Hello World
 *
 * Elementor widget for hello world.
 *
 * @since 1.0.0
 */

class SR_EssGrid extends Widget_Base {

	public function get_name() {
		return 'sr-essgrid';
	}
	public function get_title() {
		return __( 'Essential Grid', 'elementor-sonaar' );
	}

	public function get_icon() {
		return 'fas fa-th sonaar-badge';
	}
	public function get_help_url() {
		return 'https://support.sonaar.io';
	}
	public function is_reload_preview_required() {
		return true;
	}
	public function get_categories() {
		return [ 'elementor-sonaar' ];
	}

	public function get_script_depends() {
		return [ 'elementor-sonaar' ];
	}
	public function get_keywords() {
		return [ 'ess', 'grid', 'sonaar'];
	}
	protected function register_controls() {
		$this->start_controls_section(
			'section_content',
			[
				'label' => __( 'Settings', 'elementor-sonaar' ),
			]
		);
			
			$this->add_control(
				'essgrid_list',
					[
						'label'			=> esc_html__( 'Select Grid', 'elementor-sonaar' ),
						'label_block'	=> true,
						'description'	=> 'Choose a grid',
						'type'			=> \Elementor\Controls_Manager::SELECT,
						'multiple'		=> true,
						'options'		=> sr_elementor_select_essgrid(),            	
					]
			);
		$this->end_controls_section();

	}
	/**
	 * Render shortcode widget output on the frontend.
	 *
	 * Written in PHP and used to generate the final HTML.
	 *
	 * @since 1.0.0
	 * @access protected
	 */
	protected function render() {
		$settings = $this->get_settings_for_display();
		$settings = '[ess_grid alias="'. $settings['essgrid_list'] .'"][/ess_grid]';
		$settings = do_shortcode( shortcode_unautop( $settings ));
		?>
		<div class="elementor-shortcode"><?php echo $settings; ?></div>
		<?php
	}


	/**
	 * Render shortcode widget as plain content.
	 *
	 * Override the default behavior by printing the shortcode instead of rendering it.
	 *
	 * @since 1.0.0
	 * @access public
	 */
	public function render_plain_content() {
		$myshortcode = '[ess_grid alias="'. $this->get_settings( 'essgrid_list' ) .'"][/ess_grid]';
		echo $myshortcode;
	}

	
	
}


Plugin::instance()->widgets_manager->register( new SR_EssGrid() );