<?php
namespace Elementor;
if ( ! defined( 'ABSPATH' ) ) exit; // Exit if accessed directly

use Elementor\Widget_Base;
use Elementor\Controls_Manager;

/**
 * Elementor Hello World
 *
 * Elementor widget for hello world.
 *
 * @since 1.0.0
 */

class SR_RevSlider extends Widget_Base {

	public function get_name() {
		return 'sr-revslider';
	}

	public function get_title() {
		return __( 'Revolution Slider', 'elementor-sonaar' );
	}

	public function get_icon() {
		return 'fas fa-magic sonaar-badge';
	}
	public function get_help_url() {
		return 'https://support.sonaar.io';
	}
	public function get_categories() {
		return [ 'elementor-sonaar' ];
	}

	public function get_script_depends() {
		return [ 'elementor-sonaar' ];
	}
	public function get_keywords() {
		return [ 'slider', 'rev', 'carousel', 'sonaar'];
	}
	protected function register_controls() {
		$this->start_controls_section(
			'section_content',
			[
				'label' => __( 'Settings', 'elementor-sonaar' ),
			]
		);
			
			$this->add_control(
				'revslider_list',
					[
						'label'			=> esc_html__( 'Select Slider', 'elementor-sonaar' ),
						'label_block'	=> true,
						'description'	=> 'Choose a slider',
						'type'			=> \Elementor\Controls_Manager::SELECT,
						'multiple'		=> true,
						'options'		=> sr_elementor_select_slider(),            	
					]
			);
		$this->end_controls_section();

	}

	protected function render() {
		$settings = $this->get_settings();
		echo do_shortcode( '[rev_slider alias="' . $settings['revslider_list'] . '"][/rev_slider]' );
	
	}
	public function render_plain_content() {
		$myshortcode = '[rev_slider alias="'.  $this->get_settings( 'revslider_list' ) .'"][/rev_slider]';
		echo $myshortcode;
	}
	

}
Plugin::instance()->widgets_manager->register( new SR_RevSlider() );